{    var   : }
{ FE }
Unit MNL1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNL1R(N :Integer; var X :Array of Real; var XMIN :Real;
                var S :Array of Real; FUN :Proc_F1_MN; AA :Real; BB :Real;
                XE :Real; var FE :Real; var UP :Array of Real;
                var RM :Array of Real; var IERR :Integer);

implementation

procedure MNL1R(N :Integer; var X :Array of Real; var XMIN :Real;
                var S :Array of Real; FUN :Proc_F1_MN; AA :Real; BB :Real;
                XE :Real; var FE :Real; var UP :Array of Real;
                var RM :Array of Real; var IERR :Integer);
var
I,I1,ISW,ITER,IUP1,IUP2,IUP3,IX,KOUNT,L :Integer;
A,B,F,F1,F2,T1 :Real;
C :Array [0..1] of Real;
FN :Array [0..1] of Real;
V :Array [0..1] of Real;
const
R1 :Real = -0.6180340;
R2 :Real = 1.618034;
R3 :Real = 4.472136E-1;
R4 :Real = 2.078087;
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210;
begin

{     OHOMEPHA MHMA YK MHOX EPEMEHHX }
{     O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE }
{     METOOM OHA }
{     -------------------------------------------------- }
{     APAMETP: }
{     N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX }
{     X     -HAAHA TOKA OCKA }
{     XMIN  -PACCTOHE OT X O BCEHHO TOK }
{           MHMYMA BO S }
{     S     -BEKTOP H N - HAPABEHE OCKA }
{     FUN   -M OPOPAMM BCEH YHK }
{     AA,BB -HH  BEPXH PAH HTEPBAA, }
{           COEPAEO MHMYM }
{     XE    -TOHOCT O APYMEHTY }
{     FE    -TOHOCT O YHKOHAY }
{     UP    -BEKTOP YPABX APAMETPOB: }
{     UP(1) -MAKCMAHOE CO TEPA }
{     UP(2) -MAKC. CO BCEH YHK }
{     UP(3) -PHAK BAPAHTA AOPTMA }
{           UP(3)=1-HA KADO TEPA BCETC }
{                   TOKO OHA KOHTPOHA TOKA }
{           UP(3)=2-BCTC OE TOK }
{     RM    -PAO BEKTOP H N }
{     IERR  -PHAK OKOHAH POECCA: }
{           1 -OCTHYTA TOHOCT XE }
{           2 -OCTHYTA TOHOCT FE }
{           4 -BOHEHO UP(1) TEPA }
{           5 -BOHEHO UP(2) BCEH FUN }
{           65-AAHH XE.LE. }
{           66-EC (B-A).LE.G.OR.XE.GT.(B-A) }


{      ***MAHOABCME KOHCTAHT** }

{         EXTERNAL ALOG,AMAX1 }

ITER := 0;
KOUNT := 0;
IUP1 := Trunc( UP[0] + 0.5 );
IUP2 := Trunc( UP[1] + 0.5 );
IUP3 := Trunc( UP[2] + 0.5 );
if ( XE >  ZERO ) 
 then goto _10;

{      KOHEH HTEPBA .LE.  .EQ. }

IERR := 65;
goto _210;
_10:
T1 := BB - AA;
if ( T1 >  ZERO ) and (  T1 >=  XE ) 
 then goto _20;

{     HAAH HTEPBA HE OOTEH  }
{      KOHEH HTEPBA OE,EM HAAH }

IERR := 66;
goto _210;
_20:
A := AA;
B := BB;
_30:
I1 := Trunc( R4*Ln((2.0*(B-A))/XE) - 1 );
F1 := (Power(R2,I1 + 2) - Power(R1,I1 + 2))*R3;
F2 := (Power(R2,I1 + 3) - Power(R1,I1 + 3))*R3;
C[1] := F1/F2;
C[0] := 1.0 - C[1];
V[1] := C[1]*(B - A) + A;
for L:=1 to N do
 begin
  RM[L-1] := X[L-1] + V[1]*S[L-1];
_40:
 end;
FUN(RM,FN[1],FE);
KOUNT := KOUNT + 1;
IX := 1;

{      V(1),V(2)-KOHTPOHE TOK OTPEKA (A,B) }

ISW := 0;
for I:=1 to I1 do
 begin
  ITER := ITER + 1;
  if ( ITER <=  IUP1 ) 
   then goto _50;

{     BOHEHO UP(1) TEPA }

  IERR := 4;
  goto _180;
_50:
  V[IX-1] := C[IX-1]*(B - A) + A;
  for L:=1 to N do
   begin
    RM[L-1] := X[L-1] + V[IX-1]*S[L-1];
_60:
   end;
  FUN(RM,FN[IX-1],FE);
  KOUNT := KOUNT + 1;
  if ( KOUNT <=  IUP2 ) 
   then goto _70;

{      BOHEHO UP(2) BCEH YHK }

  IERR := 5;
  goto _180;

{     EC HTEPBA OTEPH,TO BOCCTAHOBEHE }

_70:
  if ( V[1] <=  V[0] ) 
   then goto _30;
  if ( Abs(FN[0] - FN[1]) >  FE*EMax1(Abs(FN[0]),Abs(
       FN[1])) ) 
   then goto _90;
  if ( ISW <>  0 ) 
   then goto _80;
  ISW := 1;
  goto _100;

{      DOCTHYTA TOHOCT FE }

_80:
  IERR := 2;
  goto _180;
_90:
  ISW := 0;
_100:
  if ( FN[0] <  FN[1] ) 
   then goto _130;
  IX := 2;
  A := V[0];

{      CTAP V(2) CTAHOBTC HOBM V(1) }

  V[0] := V[1];
  FN[0] := FN[1];
  if ( Abs(B-A) >  XE ) 
   then goto _140;
  IERR := 1;
  XMIN := V[0];
  goto _210;
_110:
  if ( IUP3 <  2 ) 
   then goto _160;
  V[0] := C[0]*(B - A) + A;
  for L:=1 to N do
   begin
    RM[L-1] := X[L-1] + V[0]*S[L-1];
_120:
   end;
  FUN(RM,FN[0],FE);
  KOUNT := KOUNT + 1;
  goto _160;
_130:
  IX := 1;
  B := V[1];

{     CTAP V(1) CTAHOBTC HOBM V(2) }

  V[1] := V[0];
  FN[1] := FN[0];
  if ( Abs(B-A) >  XE ) 
   then goto _140;
  XMIN := V[0];
  IERR := 1;
  goto _210;
_140:
  if ( IUP3 <  2 ) 
   then goto _160;
  V[1] := C[1]*(B - A) + A;
  for L:=1 to N do
   begin
    RM[L-1] := X[L-1] + V[1]*S[L-1];
_150:
   end;
  FUN(RM,FN[1],FE);
  KOUNT := KOUNT + 1;
_160:
  F := F2;
  F2 := F1;
  F1 := F - F1;
  C[1] := F1/F2;
  C[0] := 1.0 - C[1];
_170:
 end;
goto _30;

{      OPEEEHE BXOHX APAMETPOB }

_180:
if ( FN[1] - FN[0] ) < 0
 then goto _190
 else if ( FN[1] - FN[0] ) > 0
       then goto _200
       else goto _190;
_190:
XMIN := V[1];
goto _210;
_200:
XMIN := V[0];
_210:
end;

end.
